
def myUpdate(self, submit, REQUEST, urls=None):
    """
    Update my Catalog entries
    """
    user=REQUEST.AUTHENTICATED_USER
    n=0
    if urls is None: urls=[]

    if submit == " Update Selected ":
        for url in urls:
            ob=self.resolve_url(url, REQUEST)
            if ob and user.has_role('Owner', ob):
                self.catalog_object(ob, url)
                n=n+1
        message='Updated %d objects.' % n

    elif submit == " Remove Selected ":
        for url in urls:
            ob=self.resolve_url(url, REQUEST)
            if ob and user.has_role('Owner', ob):
                self.uncatalog_object(url)
                n=n+1
        message='Removed %d objects.' % n
      
    elif submit == " Update All ":
        for record in self.searchResults(creator=user.getUserName()):
            url=self.getpath(record.data_record_id_)
            ob=self.resolve_url(url, REQUEST)
            if ob and user.has_role('Owner', ob):
                self.catalog_object(ob, url)
                n=n+1
        message='Updated %d objects.' % n

    elif submit == " Remove All ":
        for record in self.searchResults(creator=user.getUserName()):
            url=self.getpath(record.data_record_id_)
            ob=self.resolve_url(url, REQUEST)
            if ob and user.has_role('Owner', ob):
                self.uncatalog_object(url)
                n=n+1
        message='Removed %d objects.' % n
 
    return self.myObjects(self, REQUEST,
            message=message)

