import string
import re
pat=re.compile(r"(http://|https://|ftp://|mailto:)(.+?)(\s|\")")

def linkf(m):
    url=m.group(1) + m.group(2)
    return """<a href="%s">%s</a>%s""" % (url, url, m.group(3))
    
def replace(text):
    "simple minded url linking"
    return re.sub(pat, linkf, text)


def plaintext(text):
    "simple text formatting"
    text=string.replace(text, '>', '&gt;')
    text=string.replace(text, '<', '&lt;')
    text=string.replace(text, '&', '&amp;')
    text=string.replace(text, '"', '&quot;')
    text=replace(text)
    text=string.replace(text, '\n', '<BR>\n')
    return text    
