import re

pat=re.compile(r"<TITLE>(.*?)</TITLE>", re.IGNORECASE)

def set_title(self):
    """
    set the title on a title-less DTML Document or Method
    by consulting the document source and looking for a
    title tag.
    """
    m=pat.search(self.read())
    if m is not None:
        title=m.group(1)
        setattr(self, 'title', title)
