
import re, urllib
sort_pat=re.compile(r'(\&)?sort(-|_)on=([^\&]+)')
order_pat=re.compile(r'(\&)?sort(-|_)order=([^&]+)')
start_pat=re.compile(r'(\&)?query_start=([^&]+)')

def sort_link(self, name, index, REQUEST):
    """
    Returns Anchor tag with appropriate link to do a sorted search.
    name is the name of the link
    index is the index to sort on
    """
    sort=None
    order=None
    klass='listheader'
    qs=REQUEST['QUERY_STRING']
    m=sort_pat.search(qs)
    if m is not None:
        sort=m.group(3)
        qs=qs[:m.start()] + qs[m.end():]
    m=order_pat.search(qs)
    if m is not None:
        order=m.group(3)
        qs=qs[:m.start()] + qs[m.end():]
    m=start_pat.search(qs)
    if m is not None:
        start=m.group(2)
        qs=qs[:m.start()] + qs[m.end():]
    qs=qs + '&sort_on=' + urllib.quote_plus(index)
    if sort==index:
        if order != 'reverse':
            qs=qs + '&sort_order=reverse'
            klass='listheader_selected'
        else:
            klass='listheader_reverse'
    return '<p class="%s"><a href="%s?%s">%s</a></p>' % (klass, REQUEST['URL'], qs, name)

